#define VERINFO "version 0.1"
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <termios.h>
#include <time.h>

int ausgabe( char *buffA , char *buffB, int lstate, char *afile){
	FILE *DataFile1;
	
	//only for debug
	printf( "%s %s %i\n", buffA , buffB, lstate);
	DataFile1 = fopen (afile, "a");
	fprintf(DataFile1, "%s %s %i\n", buffA , buffB, lstate);
	fclose (DataFile1);
}

int funcProtokoll( char *buffTime , int valZaehler1, int valZaehler2,int valZaehler3, int valZaehler4, char *afile){
	FILE *DataFile1;
	//printf( "%s %i %i %i %i\n", buffTime , valZaehler1, valZaehler2, valZaehler3, valZaehler4);
	DataFile1 = fopen (afile, "a");
	fprintf(DataFile1, "%s %i %i %i %i\n", buffTime , valZaehler1, valZaehler2, valZaehler3, valZaehler4);
	fclose (DataFile1);
}

int main(int argc, char **argv)
{
	char string[255], buff1[80],buffA[80],buffB[80], TagHeute[10], destFile[255], initFile[255], usbport[25];
	char DataFile15[255], DataFile60[255], DataFile360[255], DataFile1440[255];
	FILE *DataFile, *initfileH;
 	int i = 0; 
	//int lstateUG = 0, lstateMG = 0, lstateOG = 0, lstateGas = 0;
	int lstateUG = 0, lstateUG15 = 0,lstateUG1440 = 0,lstateUG360 = 0, lstateUG60 = 0;
	int lstateMG = 0, lstateMG15 = 0,lstateMG1440 = 0,lstateMG360 = 0, lstateMG60 = 0;
	int lstateOG = 0, lstateOG15 = 0,lstateOG1440 = 0,lstateOG360 = 0, lstateOG60 = 0;
	int lstateGas = 0, lstateGas15 = 0, lstateGas1440 = 0, lstateGas360 = 0, lstateGas60 = 0;

	int fd, prev_cts = 0, cts, prev_dts = 0, dts, prev_ets = 0, ets, prev_gts = 0, gts ;
	pid_t pid;
	struct tm  *aktuhrzeit;
	struct termios tio;	
	time_t uhrzeit;

	time_t start15Min, jetzt, start60Min ;
	time(&start15Min);
	
	//time(&jetzt);
	//start15Min + 60 * 15
	start15Min = start15Min + ((aktuhrzeit->tm_min%15) * 60);
	
	strcpy( initFile, "zwischenzaehler.ini" );
	strcpy( DataFile15, "15Minuten.txt" );
	strcpy( DataFile60, "stuendlich.txt" );
	strcpy( DataFile360, "morgens.txt" );
	strcpy( DataFile1440, "taeglich.txt" );
		
	int dtr = TIOCM_DTR;
	int rts = TIOCM_CD;
	int rng = TIOCM_RNG;
	int dsr = TIOCM_DSR;
	int lts = TIOCM_CTS;
	
 	//strcpy( destFile, "zwischenzahler.txt" );

	initfileH = fopen(initFile,"r");
	fscanf(initfileH,"%s",&usbport); //printf("%s\n", usbport);
	fscanf(initfileH,"%s",&destFile); //printf("%s\n", destFile);
	fclose(initfileH);
  
	time(&uhrzeit);	aktuhrzeit = localtime(&uhrzeit); 
	strftime(buff1,12,"%d.%m.%Y",aktuhrzeit); //Uhrzeit und Datum in aktuhrzeit

	if ((fd = open(usbport, O_RDWR)) == -1) { perror("Cannot open USB-Port"); exit(1); }
	if (tcgetattr(fd, &tio) == -1) { perror("tcgetattr() failed"); exit(1); }

	tio.c_iflag = 0;
	tio.c_oflag = 0;
	tio.c_cflag = CLOCAL|CS8;
	tio.c_lflag = 0;
	cfsetispeed(&tio, B1200);
	cfsetospeed(&tio, B1200);

	if (tcsetattr(fd, TCSANOW, &tio) == -1) { perror("tcsetattr() failed"); exit(1); }
	if (ioctl(fd, TIOCMBIS, &dtr) == -1) { perror("Cannot turn on  DTR "); exit(1); } /* turn DTR  on */
	if (ioctl(fd, TIOCMBIC, &rts) == -1) { perror("Cannot turn off RTS "); exit(1); } /* turn RTS  off - cts */
	if (ioctl(fd, TIOCMBIC, &rng) == -1) { perror("Cannot turn off RING"); exit(1); } /* turn RING off - dts */
	if (ioctl(fd, TIOCMBIC, &dsr) == -1) { perror("Cannot turn off DSR "); exit(1); } /* turn DSR  off - ets */
	if (ioctl(fd, TIOCMBIC, &lts) == -1) { perror("Cannot turn off CTS "); exit(1); } /* turn DSR  off - cts */

	/* now we fork to background */
	if ((pid = fork())<0){ perror("com server fork"); exit(1); }else if (pid > 0){ /* parent dies */ exit(0); }
	
	/* we are the child and run as a daemon */
	while(1){
	
	for (;;) {
		if (ioctl(fd, TIOCMGET, &cts) == -1) { perror("Cannot read modem signals cts"); exit(1); }
		if (ioctl(fd, TIOCMGET, &dts) == -1) { perror("Cannot read modem signals dts"); exit(1); }
		if (ioctl(fd, TIOCMGET, &ets) == -1) { perror("Cannot read modem signals ets"); exit(1); }
		if (ioctl(fd, TIOCMGET, &gts) == -1) { perror("Cannot read modem signals cts"); exit(1); }
		
		cts &= TIOCM_CD;
		dts &= TIOCM_RNG;
		ets &= TIOCM_DSR;
		gts &= TIOCM_CTS;
		
		time(&uhrzeit); aktuhrzeit = localtime(&uhrzeit); 
		strftime(buff1,80,"%d.%m.%Y %H:%M:%S",aktuhrzeit);  //Uhrzeit und Datum in aktuhrzeit
		
		if (! prev_cts && cts) {		
			ausgabe(buff1 , "ImpulsGAS ", lstateGas, destFile);
			lstateGas++;
			lstateGas15++;
			lstateGas60++;
			lstateGas1440++;
			lstateGas360++;
		}
		if (! prev_ets && ets) {
			ausgabe(buff1 , "ImpulsUG ", lstateUG, destFile);
			lstateUG++;
			lstateUG15++;
			lstateUG60++;
			lstateUG1440++;
			lstateUG360++;
		}
		if (! prev_dts && dts) {
			ausgabe(buff1 , "ImpulsOG ", lstateMG, destFile);
			lstateMG++;
			lstateMG15++;
			lstateUG60++;
			lstateMG1440++;
			lstateMG360++;
		}
		if (! prev_gts && gts) {
			ausgabe(buff1 , "ImpulsMG ", lstateOG, destFile);
			lstateOG++;
			lstateOG15++;
			lstateUG60++;
			lstateOG1440++;
			lstateOG360++;
		}
		
		prev_cts = cts;
		prev_dts = dts;
		prev_ets = ets;
		prev_ets = gts;
		
		//printf("%s", start15Min);
		
		// alle 15 Minuten
		time(&jetzt);
		if (jetzt >= start15Min + 60 * 15) {
			funcProtokoll( buff1 , lstateUG15++, lstateMG15++,lstateOG15++, lstateGas15++, DataFile15);
			lstateUG15 = 0;
			lstateMG15 = 0;
			lstateOG15 = 0;
			lstateGas15 = 0;
			usleep(100);
			start15Min = jetzt;
		}		

		// jede Stunde
		if (aktuhrzeit->tm_min == 0 && aktuhrzeit->tm_sec == 1) {
			funcProtokoll( buff1 , lstateUG60, lstateMG60,lstateOG60, lstateGas60, DataFile60);
			lstateUG60 = 0;
			lstateMG60 = 0;
			lstateOG60 = 0;
			lstateGas60 = 0;
			usleep(1000000);
		}		

		// um 06:00
		if (aktuhrzeit->tm_hour == 6 && aktuhrzeit->tm_min == 0 && aktuhrzeit->tm_sec == 10) {
			funcProtokoll( buff1 , lstateUG360, lstateMG360,lstateOG360, lstateGas360, DataFile360);
			lstateUG360 = 0;
			lstateMG360 = 0;
			lstateOG360 = 0;
			lstateGas360 = 0;
			usleep(1000000);
		}
		
		// um 00:00
		if (aktuhrzeit->tm_hour == 0 && aktuhrzeit->tm_min == 0 && aktuhrzeit->tm_sec == 12) {
			funcProtokoll( buff1 , lstateUG1440, lstateMG1440,lstateOG1440, lstateGas1440, DataFile1440);
			lstateUG1440 = 0;
			lstateMG1440 = 0;
			lstateOG1440 = 0;
			lstateGas1440 = 0;
			usleep(1000000);
		}

		usleep(5000); // 5000 Mikrosekunden - 5 millisekunden 

	}
	}
	/* we never get here */
	return (2);
}
